# Compiler flags...
CPP_COMPILER = g++
C_COMPILER = gcc

# Include paths...
Debug_Include_Path=
Release_Include_Path=

# Library paths...
Debug_Library_Path=
Release_Library_Path=

# Additional libraries...
Debug_Libraries=
Release_Libraries= 


# Preprocessor definitions...
Debug_Preprocessor_Definitions=-D GCC_BUILD -D _DEBUG -D _CONSOLE -D _CRT_SECURE_NO_WARNINGS 
Release_Preprocessor_Definitions=-D GCC_BUILD -D NDEBUG -D _CONSOLE 

# Implictly linked object files...
Debug_Implicitly_Linked_Objects=
Release_Implicitly_Linked_Objects=

# Compiler flags...
Debug_Compiler_Flags=-O0 -g 
Release_Compiler_Flags=-O2 

# Builds all configurations for this project...
.PHONY: build_all_configurations
build_all_configurations: Debug Release 

# Builds the Debug configuration...
.PHONY: Debug
Debug: create_folders ./gccDebug/Adventure.o ./gccDebug/AdvMessageData.o ./gccDebug/CCaveArray.o ./gccDebug/English.o ./gccDebug/CGameState.o ./gccDebug/LongIntArray.o ./gccDebug/RandomPercent.o ./gccDebug/ShortIntArray.o ./gccDebug/TravelArray.o ./gccDebug/TravelCave.o ./gccDebug/Vocabulary.o 
	g++ ./gccDebug/Adventure.o ./gccDebug/AdvMessageData.o ./gccDebug/CCaveArray.o ./gccDebug/English.o ./gccDebug/CGameState.o ./gccDebug/LongIntArray.o ./gccDebug/RandomPercent.o ./gccDebug/ShortIntArray.o ./gccDebug/TravelArray.o ./gccDebug/TravelCave.o ./gccDebug/Vocabulary.o  $(Debug_Library_Path) $(Debug_Libraries) -Wl,-rpath,./ -o ./gccDebug/AdventureCCaw1.exe

# Compiles file Adventure.cpp for the Debug configuration...
-include ./gccDebug/Adventure.d
./gccDebug/Adventure.o: Adventure.cpp
	$(CPP_COMPILER) $(Debug_Preprocessor_Definitions) $(Debug_Compiler_Flags) -c Adventure.cpp $(Debug_Include_Path) -o ./gccDebug/Adventure.o
	$(CPP_COMPILER) $(Debug_Preprocessor_Definitions) $(Debug_Compiler_Flags) -MM Adventure.cpp $(Debug_Include_Path) > ./gccDebug/Adventure.d

# Compiles file AdvMessageData.cpp for the Debug configuration...
-include ./gccDebug/AdvMessageData.d
./gccDebug/AdvMessageData.o: AdvMessageData.cpp
	$(CPP_COMPILER) $(Debug_Preprocessor_Definitions) $(Debug_Compiler_Flags) -c AdvMessageData.cpp $(Debug_Include_Path) -o ./gccDebug/AdvMessageData.o
	$(CPP_COMPILER) $(Debug_Preprocessor_Definitions) $(Debug_Compiler_Flags) -MM AdvMessageData.cpp $(Debug_Include_Path) > ./gccDebug/AdvMessageData.d

# Compiles file CCaveArray.cpp for the Debug configuration...
-include ./gccDebug/CCaveArray.d
./gccDebug/CCaveArray.o: CCaveArray.cpp
	$(CPP_COMPILER) $(Debug_Preprocessor_Definitions) $(Debug_Compiler_Flags) -c CCaveArray.cpp $(Debug_Include_Path) -o ./gccDebug/CCaveArray.o
	$(CPP_COMPILER) $(Debug_Preprocessor_Definitions) $(Debug_Compiler_Flags) -MM CCaveArray.cpp $(Debug_Include_Path) > ./gccDebug/CCaveArray.d

# Compiles file English.cpp for the Debug configuration...
-include ./gccDebug/English.d
./gccDebug/English.o: English.cpp
	$(CPP_COMPILER) $(Debug_Preprocessor_Definitions) $(Debug_Compiler_Flags) -c English.cpp $(Debug_Include_Path) -o ./gccDebug/English.o
	$(CPP_COMPILER) $(Debug_Preprocessor_Definitions) $(Debug_Compiler_Flags) -MM English.cpp $(Debug_Include_Path) > ./gccDebug/English.d

# Compiles file CGameState.cpp for the Debug configuration...
-include ./gccDebug/CGameState.d
./gccDebug/CGameState.o: CGameState.cpp
	$(CPP_COMPILER) $(Debug_Preprocessor_Definitions) $(Debug_Compiler_Flags) -c CGameState.cpp $(Debug_Include_Path) -o ./gccDebug/CGameState.o
	$(CPP_COMPILER) $(Debug_Preprocessor_Definitions) $(Debug_Compiler_Flags) -MM CGameState.cpp $(Debug_Include_Path) > ./gccDebug/CGameState.d

# Compiles file LongIntArray.cpp for the Debug configuration...
-include ./gccDebug/LongIntArray.d
./gccDebug/LongIntArray.o: LongIntArray.cpp
	$(CPP_COMPILER) $(Debug_Preprocessor_Definitions) $(Debug_Compiler_Flags) -c LongIntArray.cpp $(Debug_Include_Path) -o ./gccDebug/LongIntArray.o
	$(CPP_COMPILER) $(Debug_Preprocessor_Definitions) $(Debug_Compiler_Flags) -MM LongIntArray.cpp $(Debug_Include_Path) > ./gccDebug/LongIntArray.d

# Compiles file RandomPercent.cpp for the Debug configuration...
-include ./gccDebug/RandomPercent.d
./gccDebug/RandomPercent.o: RandomPercent.cpp
	$(CPP_COMPILER) $(Debug_Preprocessor_Definitions) $(Debug_Compiler_Flags) -c RandomPercent.cpp $(Debug_Include_Path) -o ./gccDebug/RandomPercent.o
	$(CPP_COMPILER) $(Debug_Preprocessor_Definitions) $(Debug_Compiler_Flags) -MM RandomPercent.cpp $(Debug_Include_Path) > ./gccDebug/RandomPercent.d

# Compiles file ShortIntArray.cpp for the Debug configuration...
-include ./gccDebug/ShortIntArray.d
./gccDebug/ShortIntArray.o: ShortIntArray.cpp
	$(CPP_COMPILER) $(Debug_Preprocessor_Definitions) $(Debug_Compiler_Flags) -c ShortIntArray.cpp $(Debug_Include_Path) -o ./gccDebug/ShortIntArray.o
	$(CPP_COMPILER) $(Debug_Preprocessor_Definitions) $(Debug_Compiler_Flags) -MM ShortIntArray.cpp $(Debug_Include_Path) > ./gccDebug/ShortIntArray.d

# Compiles file TravelArray.cpp for the Debug configuration...
-include ./gccDebug/TravelArray.d
./gccDebug/TravelArray.o: TravelArray.cpp
	$(CPP_COMPILER) $(Debug_Preprocessor_Definitions) $(Debug_Compiler_Flags) -c TravelArray.cpp $(Debug_Include_Path) -o ./gccDebug/TravelArray.o
	$(CPP_COMPILER) $(Debug_Preprocessor_Definitions) $(Debug_Compiler_Flags) -MM TravelArray.cpp $(Debug_Include_Path) > ./gccDebug/TravelArray.d

# Compiles file TravelCave.cpp for the Debug configuration...
-include ./gccDebug/TravelCave.d
./gccDebug/TravelCave.o: TravelCave.cpp
	$(CPP_COMPILER) $(Debug_Preprocessor_Definitions) $(Debug_Compiler_Flags) -c TravelCave.cpp $(Debug_Include_Path) -o ./gccDebug/TravelCave.o
	$(CPP_COMPILER) $(Debug_Preprocessor_Definitions) $(Debug_Compiler_Flags) -MM TravelCave.cpp $(Debug_Include_Path) > ./gccDebug/TravelCave.d

# Compiles file Vocabulary.cpp for the Debug configuration...
-include ./gccDebug/Vocabulary.d
./gccDebug/Vocabulary.o: Vocabulary.cpp
	$(CPP_COMPILER) $(Debug_Preprocessor_Definitions) $(Debug_Compiler_Flags) -c Vocabulary.cpp $(Debug_Include_Path) -o ./gccDebug/Vocabulary.o
	$(CPP_COMPILER) $(Debug_Preprocessor_Definitions) $(Debug_Compiler_Flags) -MM Vocabulary.cpp $(Debug_Include_Path) > ./gccDebug/Vocabulary.d

# Builds the Release configuration...
.PHONY: Release
Release: create_folders ./gccRelease/Adventure.o ./gccRelease/AdvMessageData.o ./gccRelease/CCaveArray.o ./gccRelease/English.o ./gccRelease/CGameState.o ./gccRelease/LongIntArray.o ./gccRelease/RandomPercent.o ./gccRelease/ShortIntArray.o ./gccRelease/TravelArray.o ./gccRelease/TravelCave.o ./gccRelease/Vocabulary.o 
	g++ ./gccRelease/Adventure.o ./gccRelease/AdvMessageData.o ./gccRelease/CCaveArray.o ./gccRelease/English.o ./gccRelease/CGameState.o ./gccRelease/LongIntArray.o ./gccRelease/RandomPercent.o ./gccRelease/ShortIntArray.o ./gccRelease/TravelArray.o ./gccRelease/TravelCave.o ./gccRelease/Vocabulary.o  $(Release_Library_Path) $(Release_Libraries) -Wl,-rpath,./ -o ./gccRelease/AdventureCCaw1.exe

# Compiles file Adventure.cpp for the Release configuration...
-include ./gccRelease/Adventure.d
./gccRelease/Adventure.o: Adventure.cpp
	$(CPP_COMPILER) $(Release_Preprocessor_Definitions) $(Release_Compiler_Flags) -c Adventure.cpp $(Release_Include_Path) -o ./gccRelease/Adventure.o
	$(CPP_COMPILER) $(Release_Preprocessor_Definitions) $(Release_Compiler_Flags) -MM Adventure.cpp $(Release_Include_Path) > ./gccRelease/Adventure.d

# Compiles file AdvMessageData.cpp for the Release configuration...
-include ./gccRelease/AdvMessageData.d
./gccRelease/AdvMessageData.o: AdvMessageData.cpp
	$(CPP_COMPILER) $(Release_Preprocessor_Definitions) $(Release_Compiler_Flags) -c AdvMessageData.cpp $(Release_Include_Path) -o ./gccRelease/AdvMessageData.o
	$(CPP_COMPILER) $(Release_Preprocessor_Definitions) $(Release_Compiler_Flags) -MM AdvMessageData.cpp $(Release_Include_Path) > ./gccRelease/AdvMessageData.d

# Compiles file CCaveArray.cpp for the Release configuration...
-include ./gccRelease/CCaveArray.d
./gccRelease/CCaveArray.o: CCaveArray.cpp
	$(CPP_COMPILER) $(Release_Preprocessor_Definitions) $(Release_Compiler_Flags) -c CCaveArray.cpp $(Release_Include_Path) -o ./gccRelease/CCaveArray.o
	$(CPP_COMPILER) $(Release_Preprocessor_Definitions) $(Release_Compiler_Flags) -MM CCaveArray.cpp $(Release_Include_Path) > ./gccRelease/CCaveArray.d

# Compiles file English.cpp for the Release configuration...
-include ./gccRelease/English.d
./gccRelease/English.o: English.cpp
	$(CPP_COMPILER) $(Release_Preprocessor_Definitions) $(Release_Compiler_Flags) -c English.cpp $(Release_Include_Path) -o ./gccRelease/English.o
	$(CPP_COMPILER) $(Release_Preprocessor_Definitions) $(Release_Compiler_Flags) -MM English.cpp $(Release_Include_Path) > ./gccRelease/English.d

# Compiles file CGameState.cpp for the Release configuration...
-include ./gccRelease/CGameState.d
./gccRelease/CGameState.o: CGameState.cpp
	$(CPP_COMPILER) $(Release_Preprocessor_Definitions) $(Release_Compiler_Flags) -c CGameState.cpp $(Release_Include_Path) -o ./gccRelease/CGameState.o
	$(CPP_COMPILER) $(Release_Preprocessor_Definitions) $(Release_Compiler_Flags) -MM CGameState.cpp $(Release_Include_Path) > ./gccRelease/CGameState.d

# Compiles file LongIntArray.cpp for the Release configuration...
-include ./gccRelease/LongIntArray.d
./gccRelease/LongIntArray.o: LongIntArray.cpp
	$(CPP_COMPILER) $(Release_Preprocessor_Definitions) $(Release_Compiler_Flags) -c LongIntArray.cpp $(Release_Include_Path) -o ./gccRelease/LongIntArray.o
	$(CPP_COMPILER) $(Release_Preprocessor_Definitions) $(Release_Compiler_Flags) -MM LongIntArray.cpp $(Release_Include_Path) > ./gccRelease/LongIntArray.d

# Compiles file RandomPercent.cpp for the Release configuration...
-include ./gccRelease/RandomPercent.d
./gccRelease/RandomPercent.o: RandomPercent.cpp
	$(CPP_COMPILER) $(Release_Preprocessor_Definitions) $(Release_Compiler_Flags) -c RandomPercent.cpp $(Release_Include_Path) -o ./gccRelease/RandomPercent.o
	$(CPP_COMPILER) $(Release_Preprocessor_Definitions) $(Release_Compiler_Flags) -MM RandomPercent.cpp $(Release_Include_Path) > ./gccRelease/RandomPercent.d

# Compiles file ShortIntArray.cpp for the Release configuration...
-include ./gccRelease/ShortIntArray.d
./gccRelease/ShortIntArray.o: ShortIntArray.cpp
	$(CPP_COMPILER) $(Release_Preprocessor_Definitions) $(Release_Compiler_Flags) -c ShortIntArray.cpp $(Release_Include_Path) -o ./gccRelease/ShortIntArray.o
	$(CPP_COMPILER) $(Release_Preprocessor_Definitions) $(Release_Compiler_Flags) -MM ShortIntArray.cpp $(Release_Include_Path) > ./gccRelease/ShortIntArray.d

# Compiles file TravelArray.cpp for the Release configuration...
-include ./gccRelease/TravelArray.d
./gccRelease/TravelArray.o: TravelArray.cpp
	$(CPP_COMPILER) $(Release_Preprocessor_Definitions) $(Release_Compiler_Flags) -c TravelArray.cpp $(Release_Include_Path) -o ./gccRelease/TravelArray.o
	$(CPP_COMPILER) $(Release_Preprocessor_Definitions) $(Release_Compiler_Flags) -MM TravelArray.cpp $(Release_Include_Path) > ./gccRelease/TravelArray.d

# Compiles file TravelCave.cpp for the Release configuration...
-include ./gccRelease/TravelCave.d
./gccRelease/TravelCave.o: TravelCave.cpp
	$(CPP_COMPILER) $(Release_Preprocessor_Definitions) $(Release_Compiler_Flags) -c TravelCave.cpp $(Release_Include_Path) -o ./gccRelease/TravelCave.o
	$(CPP_COMPILER) $(Release_Preprocessor_Definitions) $(Release_Compiler_Flags) -MM TravelCave.cpp $(Release_Include_Path) > ./gccRelease/TravelCave.d

# Compiles file Vocabulary.cpp for the Release configuration...
-include ./gccRelease/Vocabulary.d
./gccRelease/Vocabulary.o: Vocabulary.cpp
	$(CPP_COMPILER) $(Release_Preprocessor_Definitions) $(Release_Compiler_Flags) -c Vocabulary.cpp $(Release_Include_Path) -o ./gccRelease/Vocabulary.o
	$(CPP_COMPILER) $(Release_Preprocessor_Definitions) $(Release_Compiler_Flags) -MM Vocabulary.cpp $(Release_Include_Path) > ./gccRelease/Vocabulary.d

# Creates the intermediate and output folders for each configuration...
.PHONY: create_folders
create_folders:
	mkdir -p ./gccDebug/source
	mkdir -p ./gccRelease/source

# Cleans intermediate and output files (objects, libraries, executables)...
.PHONY: clean
clean:
	rm -f ./gccDebug/*.o
	rm -f ./gccDebug/*.d
	rm -f ./gccDebug/*.a
	rm -f ./gccDebug/*.so
	rm -f ./gccDebug/*.dll
	rm -f ./gccDebug/*.exe
	rm -f ./gccRelease/*.o
	rm -f ./gccRelease/*.d
	rm -f ./gccRelease/*.a
	rm -f ./gccRelease/*.so
	rm -f ./gccRelease/*.dll
	rm -f ./gccRelease/*.exe

